<template>
  <h2>Add Resource</h2>
  <base-card>
    <form @submit.prevent="submitResource">
      <div class="form-control">
        <label for="title">Title</label>
        <input id="title" name="title" type="text" ref="titleInput"/>
      </div>

      <div class="form-control">
        <label for="description">Description</label>
        <textarea name="description" id="description" rows="3" ref="descriptionInput"></textarea>
      </div>

      <div class="form-control">
        <label for="link">Link</label>
        <input id="link" name="link" type="url" ref="linkInput"/>
      </div>

      <div>
        <base-button type="submit">Add Resource</base-button>
      </div>
    </form>
  </base-card>
  <teleport to="body">
    <base-dialog v-if="inputIsInvalid" title="Invalid Input" @close="confirmError">
      <template #default>
        <p>Unfortunately, at least one input value is invalid.</p>
        <p>Please check all inputs and make sure you entered at least a few characters into each input field</p>
      </template>
      <template v-slot:actions>
        <base-button @click="confirmError">Okay</base-button>
      </template>
    </base-dialog>
  </teleport>
</template>



<script>
import BaseButton from '../UI/BaseButton.vue';
import BaseDialog from '../UI/BaseDialog.vue';

export default {
  inject: ['addResource'],
  components: { BaseButton, BaseDialog },
  data() {
    return {
      inputIsInvalid: false,
    }
  },
  methods: {
    submitResource() {
      const enteredTitle = this.$refs.titleInput.value.trim();
      const enteredDescription = this.$refs.descriptionInput.value.trim();
      const enteredLink = this.$refs.linkInput.value.trim();

      const resourceObject = {
        title: enteredTitle,
        description: enteredDescription,
        link: enteredLink,
      }

      if(enteredTitle === '' || enteredDescription === '' || enteredLink === '') {
        this.inputIsInvalid = true;
        return;
      }
      
      this.addResource(resourceObject);
    },
    confirmError() {
      this.inputIsInvalid = false;
    }
  },
};
</script>

<style scoped>
label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  padding: 0.15rem;
  border: 1px solid #ccc;
}

input:focus,
textarea:focus {
  outline: none;
  border-color: #3a0061;
  background-color: #f7ebff;
}

.form-control {
  margin: 1rem 0;
}

.dialog {
  display: flex;
  justify-self: center;
  align-items: center;
  flex-direction: column;
}
</style>
